HC = require ("hardoncollider")
cron = require ("cron")

speed = 200
char_x = 216 -- new variables for the sprite position
char_y = 216
attackdraw = false
attackdir = 4
attacktime = 0

function on_collide( dt, shape_a, shape_b)
	if shape_a == "char" then
	    playerCollision(shape_b)
	elseif shape_b == "char" then
	    playerCollision(shape_a)
	end
end

function playerCollision( shape )
	print("collided!")
end

function killAttack()
	if attackdraw then
		Collider:remove(attack)
    	attackdraw = false
	end
end

function testCron()
	print("Five seconds have passed!")
end

local tester = cron.after(5, testCron)

function love.load(  )
	Collider = HC(100, on_collide)

	char = Collider:addRectangle(200, 200, 48, 92)
	char.type = "player"
	enemy1 = Collider:addRectangle(282, 232, 32, 32)
	enemy1.type = "enemy"
	enemy2 = Collider:addRectangle(282, 200, 32, 32)
	enemy2.type = "enemy"
	enemy3 = Collider:addRectangle(250, 232, 32, 32)
	enemy3.type = "enemy"
	enemies = {enemy1,enemy2,enemy3}

	alsina = love.graphics.newFont("fonts/Alsina_Ultrajada.TTF", 15)
	love.graphics.setFont(alsina)
	char_sprite = love.graphics.newImage("char-front.png")

	dx = 0
	dy = 0

	if not on_collide then
		dx, dy = char:center()
	end
end

function love.update( dt ) -- Changed all the elseifs into seperate if statements to allow for diagonal movement
	function movement(x,y) --collision is now done from this functiom
		x,y = char_x + x, char_y + y --adds the movement to the current char position
		char:moveTo(x,y) --moves the character to the correct space
		for i,v in ipairs(enemies) do --this loop goes through all the enemies
			if char:collidesWith(v) then --this checks if the object is colliding
				colliding = true
				char:moveTo(char_x,char_y) --if it is, then it moves back to the position before it moved
			end
		end
		if colliding ~= true then
			char_x,char_y = x,y --if it isn't then the character sprite moves there as well
		end
		colliding = false --this has to be reset for the next time you move
	end


	if love.keyboard.isDown("up") then
		movement(0, -1 * speed * dt)
		attackdir = 1
	end
	if love.keyboard.isDown("down") then
		movement(0, 1 * speed * dt)
		attackdir = 2
	end
	if love.keyboard.isDown("left") then
		movement(-1 * speed * dt, 0)
		attackdir = 3
	end
	if love.keyboard.isDown("right") then
		movement(1 * speed * dt, 0)
		attackdir = 4
	end

	if tester then
	    tester:update(dt)
	end
	if attackdraw then
    	if killTester then
		    killTester:update(dt)
		end
	end

	Collider:update(5)

	function newAttack()
		if not attackdraw then
			if attackdir == 1 then
			    attack = Collider:addRectangle(char_x - 8, char_y - 48, 16, 16)
			    attack.type = "attack"
			    attackdraw = true
			    killTester = cron.after(1, killAttack)
			elseif attackdir == 2 then
			    attack = Collider:addRectangle(char_x - 8, char_y + 32, 16, 16)
			    attack.type = "attack"
			    attackdraw = true
			    killTester = cron.after(1, killAttack)
			elseif attackdir == 3 then
			    attack = Collider:addRectangle(char_x - 48, char_y - 8, 16, 16)
			    attack.type = "attack"
			    attackdraw = true
			    killTester = cron.after(1, killAttack)
			elseif attackdir == 4 then
			    attack = Collider:addRectangle(char_x + 32, char_y - 8, 16, 16)
			    attack.type = "attack"
				attackdraw = true
				killTester = cron.after(1, killAttack)
			end
		end
	end
end

function love.keypressed(key)
	if key == " " then
		newAttack()
	end
end

function love.draw(  )
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(char_sprite, char_x - 32, char_y - 78, 0, 1, 1, 1, 1)
	enemy1:draw("fill")
	enemy2:draw("fill")
	enemy3:draw("fill")

	if attackdraw then
		love.graphics.setColor(100, 255, 100, 255)
		attack:draw("fill")
	end


	love.graphics.setColor(255, 255, 255, 255)

	--print(attackdraw)
	--print(attackdir)

	love.graphics.print("Movement Demo ver.0.3", 1, 1)
	love.graphics.print("Hardon Collider", 710, 1)
	love.graphics.print("Space to attack!", 1, 580)

--	love.graphics.print("X : " .. px .. ", Y : " .. py, 1,1)

--	love.graphics.print("X: " .. dx .. ", Y: " .. dy, 1, 599)
end